/* source/config.h: configuration definitions

   Copyright (c) 1989-91 James E. Wilson

   This software may be copied and distributed for educational, research, and
   not for profit purposes provided that this copyright and statement are
   included in all such copies. */

#define CONFIG_H_INCLUDED
#ifdef CONSTANT_H_INCLUDED
Constant.h should always be included after config.h, because it uses
some of the system defines set up here.
#endif

/* Person to bother if something goes wrong.  */
/* Recompile files.c and misc2.c if this changes.  */
/* CHANGE HERE */

#define WIZARD	"Tim Nali"

/* The wizard password and wizard uid are no longer used.  */


/* don't change the following two defines */
#ifndef ultrix
#define ultrix
#endif
#ifndef Linux
#define Linux
#endif

/* Linux people.  Here are the paths to change */
/* moria.save will be placed in the user's home directory */
/* CHANGE HERE */

#define MORIA_SAV	"moria.save"

/*  If all these are not in the same directory, the install part of make
    won't work properly.  Either change the install part of the Makefile
    or remove the word `install'  from the following line in Makefile
              all:  moria utils install
    and install everything manually.  (This just amounts to copying the files
    into the right directories and doing the chmod commands listed in
    the Makefile, not too diffciult)                   */
/* CHANGE HERE */

#define MORIA_HOU	"/usr/games/lib/umoria/hours"
#define MORIA_MOR	"/usr/games/lib/umoria/news"
#define MORIA_TOP	"/usr/games/lib/umoria/scores"
#define MORIA_HELP	"/usr/games/lib/umoria/roglcmds.hlp"
#define MORIA_ORIG_HELP	"/usr/games/lib/umoria/origcmds.hlp"
#define MORIA_WIZ_HELP	"/usr/games/lib/umoria/rwizcmds.hlp"
#define MORIA_OWIZ_HELP	"/usr/games/lib/umoria/owizcmds.hlp"
#define MORIA_WELCOME	"/usr/games/lib/umoria/welcome.hlp"
#define MORIA_VER	"/usr/games/lib/umoria/version.hlp"


/* This sets the default user interface.  */
/* To use the original key bindings (keypad for movement) set ROGUE_LIKE
   to FALSE; to use the rogue-like key bindings (vi style movement)
   set ROGUE_LIKE to TRUE.  */
/* If you change this, you only need to recompile main.c.  */
/* CHANGE HERE */
#define ROGUE_LIKE FALSE






/* System dependent defines follow.  You should not need to change anything
   below.  */

#ifdef ATARIST_TC
#define USG
#include <stdio.h>	/* Needed for TC ...printf */
#endif

#if defined(ATARIST_TC) || defined(ATARIST_MWC)
#define ATARI_ST
#endif

/* Substitute strchr for index on USG versions of UNIX.  */
#if defined(SYS_V) || defined(MSDOS) || defined(MAC) || defined(VMS)
#define index strchr
#endif

#ifdef SYS_III
char *index();
#endif

/* Define USG for many systems, this is basically to select SYS V style
   system calls (as opposed to BSD style).  */
#if defined(SYS_III) || defined(SYS_V) || defined(MSDOS) || defined(MAC)
#ifndef USG
#define USG
#endif
#endif

#if defined(ATARIST_MWC) || defined(AMIGA) || defined(VMS)
#define USG
#endif

#ifdef AMIGA
#ifndef ultrix
#define ultrix
#endif
#endif

/* Pyramid runs 4.2BSD-like UNIX version */
#if defined(Pyramid)
#define ultrix
#endif

#if !defined(_MSC_VER) || _MSC_VER < 600
#define register      /* MSC 4.0 still has a problem with register bugs ... */
#endif

#ifdef MAC
#ifdef RSRC
#define MACRSRC		/* Defined if we are building the resources.  */
#else
#define MACGAME		/* Defined if we are building the game.  */
#endif
#endif

#ifdef MAC
/* Screen dimensions */
#define SCRN_ROWS	24
#define SCRN_COLS	80
#endif

#ifdef THINK_C
/* I don't think any of this is necessary for MPW C.  -BS-  */
/* #define RSRC */	/* This copy is for creating resources.  */

/* Think C can only take 32K data, so we need to dump the resources in
   two parts:	*/
/* #define RSRC_PART1 */
/* #define RSRC_PART2 */
#endif

#ifdef VMS
#define unlink delete
#define index strchr
#define exit uexit
/* In constants.h, ESCAPE is defined to be the CTRL-Z key, instead of the
   escape key.  */
#endif

#if defined(SYS_V) && defined(lint)
/* Define this to prevent <string.h> from including <NLchar.h> on a PC/RT
   running AIX.  This prevents a bunch of lint errors.  */
#define RTPC_NO_NLS
#endif

#ifdef SECURE
extern int PlayerUID;
/* Linux patch
#define getuid() PlayerUID
#define geteuid() PlayerUID */
#define PlayerUID getuid()

#endif

#ifdef THINK_C
/* Apparently, THINK C is only happy if this is defined.  This can not
   be defined in general, because some systems have include files which
   merely test whether STDC is defined, they do not test the value.  */
/* Check how standard we are: Some code tests value of __STDC__.  */
#ifndef __STDC__
#define __STDC__	0
#endif
#endif
